#include <bits/stdc++.h>
#define ll long long
#define MAXN 200002
#define logn 19
using namespace std;
vector<ll> G[MAXN];
ll in[MAXN],out[MAXN],D[MAXN],up[MAXN][logn],a[MAXN],tr,sum[MAXN],dp[MAXN],res=LLONG_MAX,ind,c[MAXN];
void DFS_Pocetak(ll i,ll p)
{
    sum[i]=a[i];
    for (ll next : G[i])
    {
        if (next!=p)
        {
            DFS_Pocetak(next,i);
            sum[i]+=sum[next];
            dp[i]+=dp[next]+sum[next];
        }
    }
}
void DFS(ll i,ll p,ll cur)
{
    c[i]=dp[i]+cur;
    if (c[i]<res)
    {
        res=c[i];
        ind=i;
    }
    else if (c[i]==res)
        ind=min(i,ind);
    for (ll next : G[i])
    {
        if (next!=p)
            DFS(next,i,c[i]-dp[next]+sum[1]-2*sum[next]);
    }
}
void DFS_1(ll i,ll p)
{
    D[i]=D[p]+1;
    up[i][0]=p;
    in[i]=tr;
    tr++;
    for (ll j=1;j<logn;j++)
        up[i][j]=up[up[i][j-1]][j-1];
    for (ll next : G[i])
    {
        if (next!=p)
            DFS_1(next,i);
    }
    out[i]=tr;
    tr++;
}
bool Is_Ancestor(ll u,ll v)
{
    return (in[u]<=in[v] && out[u]>=out[v]);
}
ll LCA(ll u,ll v)
{
    if (Is_Ancestor(u,v))
        return u;
    if (Is_Ancestor(v,u))
        return v;
    for (ll i=logn-1;i>=0;i--)
    {
        if (!Is_Ancestor(up[u][i],v))
            u=up[u][i];
    }
    return up[u][0];
}
ll Distance(ll u,ll v)
{
    ll l=LCA(u,v);
    return D[u]+D[v]-2*D[l];
}
int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    ll n,x,y,q;
    cin >> n;
    for (ll i=1;i<n;i++)
    {
        cin >> x >> y;
        G[x].push_back(y);
        G[y].push_back(x);
    }
    for (ll i=1;i<=n;i++)
        cin >> a[i];
    cin >> q;
    DFS_1(1,1);
    if (n<=1000 && !q)
    {
        for (ll i=1;i<=n;i++)
        {
            ll t=0;
            for (ll j=1;j<=n;j++)
                t+=a[j]*Distance(i,j);
            if (t<res)
            {
                res=t;
                ind=i;
            }
        }
        cout << ind << "\n";
        return 0;
    }
    if (!q)
    {
        DFS_Pocetak(1,1);
        DFS(1,1,0);
        cout << ind << "\n";
    }
    return 0;
}